#ifndef _PROJECT
#include "project.h"
#endif

#ifndef _PROCFILE
#include "processfile.h"
#endif

#include "sendrecvmsg.h"
#include "msgprocessing.h"
#include "FTprocedure.h"
#include <algorithm>

typedef map<string,string> Tcommandset;
typedef map<string,unsigned int> Tcommandtable;

extern string redir_ipaddr;
extern int    redir_port; 

const int COMMAND_SPACE_TO_PRINT = 25;

void InitCommandSet(Tcommandset &commandset, Tcommandtable &commandtable);
SOCKDESCR GetServerConnection(SOCKDESCR sockfd, SA_IN &addr, Tservtable servtable);
void ShowCommandSet(Tcommandset commandset);
void ShowCommandSet(Tcommandset commandset, string command);
void ShowFileList(const Tstringlist &filelist);
int  RefreshFileList(Tstringlist &filelist);

int ExecuteListCommand(SOCKDESCR sockfd);
int ExecuteGetCommand(SOCKDESCR sockfd, const Tstringlist &filelist, string remotefile, string localfile, string &redir_ipaddr, int &redir_ipport);
int ExecuteUpdateCommand(SOCKDESCR sockfd, const Tstringlist &filelist, string filename);
