#ifndef _PROJECT
#define _PROJECT
#endif

//#ifndef _MYSOCKHEAD
#include "mysocketheader.h"
//#endif

//string incluso in mysockheader
#include <vector>
#include <map>
#include <fstream>

//define per la gestione dei filedb------------
#define FILEDB_BEGIN_TAG     ("BEGIN_OF_FILE")
#define FILEDB_END_TAG       ("END_OF_FILE")
#define FILEDB_END_OF_LINE   ("EOF")
#define CLIENT_FILELIST_NAME ("client_file.tmp")
#define MAX_GUARD 10000

#define FIRST_SPACE 24
#define SPACE ("    ")

#define FILELIST_COLUMNS 3
#define FILE_SPACE_TO_PRINT 25
//--------------------------------------------------
#define EPHE_LOW_BOUND 2000
#define EPHE_HIGH_BOUND  20000
#define SERVER_FOR_CLIENT_PORT 45000
#define SERVER_FOR_SERVER_PORT 50000
#define SENDMSG_TIMEOUT 30
#define RECVMSG_TIMEOUT 30
#define MAXLISTEN 10
//---------------------------------------------------
#define SERVERDB_DEFAULT_NAME    ("server.db")  //nome del file contenente le info sui server: lato server
#define CLIENT_SERVER_FILENAME ("client_server.db") //file contenente le info sui server laoto cleint
#define FILEDB_DEFAULT_NAME    ("file.db") //file contenente il DATABASE dei file nel sistema (solo server side)
#define SERVER_FILELIST_TEMP_NAME  ("fed.filelist.temp") //nome della LISTA dei file nel server
#define CLIENT_FILELIST_TEMP_NAME   ("fed.filelist.temp") //nome del file della LISTA dei file nel sistema
#define CACHING_TEMP_FILENAME  ("___tempcache.") //server side: file temporaneo per il caching
#define SERVER_TEMPFILEDB_NAME ("___temp.file.db")

const int CACHE_THRESHOLD = 10;
const int FETCH_ON_WRITE_THRESHOLD = 15;
const int DELTA_ACCESS = 5;
const int MAX_PSOPROTO_RESTART = 5;
//-----------------------------------------------------------
#define WORK    01  //server up
#define NOWORK  00  //server down
#define OWNED   10  //un file e' owned quando non esistono altre copie
#define CACHED  20  //cached significa che esistono altre copie valide
#define REMOTE  30  //il file e' allocato su un altro server

#define OPEN    90  //il file locale e' attualmente in uso
#define CLOSED  80  //il file locale 
#define LOCKED  70  //il file locale e' locked
#define NONE    60
//--------------------------------------------------
#define MAX_RESUME_TIME 3
//----------------------------------------
#define COMMAND_PROMPT ("fed command? ->")
#define SIMULA_UPDATE 7
//------------------------------------------
//#define MAX_FILENAME_NUM 1000.0
//#define TEMP_FILENAME    "fedtempfile.tmp"
//-----------------------------------
const unsigned int CLICOMM_UNKNOWN          = 100; //comando non riconosciuto
const unsigned int CLICOMM_LIST             = 101; //richiesta lista file disponibili
const unsigned int CLICOMM_GET              = 102; //richiesta download file
const unsigned int CLICOMM_PUT              = 103; //richiesta upload file
const unsigned int CLICOMM_UPDATE           = 104; //richiesta update file (dummy, per ora)
const unsigned int CLICOMM_DELETE           = 105; //richiesta cancellazione file
const unsigned int CLICOMM_CONNECT          = 106; //richiesta connessione esplicita a server
const unsigned int CLICOMM_DISCONNECT       = 107; //richiesta disconnessione
const unsigned int CLICOMM_LOCK             = 108; //richiesta di lockin sul file specificato
const unsigned int CLICOMM_SHOW_COMMANDSET  = 109;
const unsigned int CLICOMM_SHOW_HELP        = 110;
const unsigned int CLICOMM_SHELL            = 111;
const unsigned int CLICOMM_SHOW_LIST        = 112;
const unsigned int CLICOMM_UPDATE_WITH_CACHE= 113;

//const unsigned int SERVER_INPUT             = 201;
//------------------------------------------------------------------------
const unsigned int SERV_SIMPLE_ACK          = 300;
const unsigned int SERV_GET_ACK             = 301;
const unsigned int SERV_DENY                = 302;
const unsigned int SERV_REDIR               = 303;
const unsigned int SERV_CACHE_INV           = 304;
const unsigned int SERV_PASS_OWNERSHIP      = 305;
const unsigned int SERV_NOTOWNED            = 306;
//-----------------------------------------------------------------------
//fla utilizzati dalla ProcessMessageForServer per discriminare
//se il comando proviene da un client o da un server
const unsigned int CLIENT_COMMAND           = 501;  
const unsigned int SERVER_COMMAND           = 502;
const unsigned int SIMPLE_ACK               = 503;  //si usa quando e' il client a dover mandare l' ack
//------------------------------------------------------------------------- 
//*****************
#define TOKEN 512	//dimensione massima di un singolo messaggio
//*****************

#define MAX_COPYBUFFER_LEN 512
//--------------------------

//identificatori dei messaggi scambiati
const unsigned int ACK       = 1100;  //ACKNOWLEDGE generale
const unsigned int DENY      = 1101;  //risposta negativa a request
const unsigned int REDIR     = 1102;  //risposta con redirection ad altro server
const unsigned int UNKN      = 1103;  //COMMAND UNKNOWN
const unsigned int LST_MSG   = 1104;  //list request
const unsigned int GET_MSG   = 1105;  //get request
const unsigned int PUT_MSG   = 1106;  //put request
const unsigned int UPD_MSG   = 1107;  //udpate request
const unsigned int DLT_MSG   = 1108;  //delete request
const unsigned int LCK_MSG   = 1109;  //lock request
const unsigned int CAC_REQ   = 1110;  //S: richiesta di caching file
const unsigned int CAC_INV   = 1111;  //S: informazione di invalidate cache
const unsigned int UPD_FDB   = 1112;  //S: aggiorna file.db
const unsigned int RES_FDB   = 1113;  //S: richiesta di resume del file.db
const unsigned int GRANTED   = 1114;  //specialized grant
const unsigned int NOGRANT   = 1115;  //grant rejected
const unsigned int DCT_MSG   = 1116;  //disconnect req
const unsigned int UNC_MSG   = 1117;  //update with no caching allowed
const unsigned int PSO_MSG   = 1118;  //pass owner message
const unsigned int NOT_OWN   = 1119;  //il server dice che non possiede il file
//-------------------------------------------------------------------------


//--------------------------------------------------------------------------
typedef vector<string> Tstringlist;	//vettore contenente liste di filename o comandi disponibili

typedef struct{
	int id;
	string arg1;
	string arg2;
	string arg3;
} Tcommandstruct;

typedef struct{
	int     msg_type;
	string  ipaddr;
	int     port;
	int     filelen;
}Trepl;

typedef struct{
	int    msg_type;
	string arg1;
	string arg2;
}Tclicomm;

typedef struct{
	string name;
	string addr;
	int port;
	string msg;
}Tbroad;

typedef struct{
	string name;
	int status;
}Tbroadstatus;
